#define _GNU_SOURCE

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

# include <windows.h>
# include <imagehlp.h>
# include <tlhelp32.h>

static void winerror(const char* msg) {
    LPVOID lpMsgBuf;

    //˥å

    FormatMessage(              //顼ɽʸ
        FORMAT_MESSAGE_ALLOCATE_BUFFER |
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL, GetLastError(),
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf, 0, NULL);

    printf("%s: %s", msg, (const char*)lpMsgBuf);
//    MessageBox(NULL, (const char*)lpMsgBuf, NULL, MB_OK);   //åɽ

    LocalFree(lpMsgBuf);
}

typedef void (*regsym_cb) (const char*, void*);

/*
static int load_arch(regsym_cb fp, MODULEENTRY32* me) {
    char buf[1024];
    FILE* f;
    if (!GetModuleFileName(me->hModule, buf, 1024)) {
        winerror("GetModuleFileName");
        return 1;
    }
    f = fopen(buf, "rb");
    if (f) {
        fclose(f);
        return read_symbols(fp, buf, (int)me->modBaseAddr);
    }
    printf("%s: not found. Is it WINE?\n", buf);
    return 0;
}
*/

char program_name[4096];

static int __stdcall regist_loaded(LPSTR name, ULONG addr,
                                   ULONG size, PVOID ctx)
{
    regsym_cb fp = (regsym_cb)ctx;
//    printf("[C] %x %s\n", addr, name);
    fp(name, (void*)addr);
    return TRUE;
}

static int init_arch(regsym_cb fp) {
    HANDLE h;
    DWORD base;
    HANDLE ss;
    MODULEENTRY32 me;
    char buf[4096];

    h = GetCurrentProcess();
    if (!SymInitialize(h, NULL, FALSE)) {
        winerror("SymInitialize");
        return 1;
    }
    ss = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, 0);
    if (!ss) {
        perror("CreateToolhelp32Snapshot");
        return 1;
    }
    me.dwSize = 1024;
    if (!Module32First(ss, &me)) {
        perror("Module32First");
        return 1;
    }
    GetModuleFileName(me.hModule, buf, 4096);
    strcpy(program_name, buf);
    base = SymLoadModule(h, NULL, buf, NULL, 0, 0);
    if (base == 0) {
        winerror("SymLoadModule");
        return 1;
    }
    if (!SymEnumerateSymbols(h, base, regist_loaded, fp)) {
        winerror("SymEnemerateSymbols");
        return 1;
    }
/*
    if (!SymUnloadModule(h, base)) {
        winerror("SymUnloadModule");
        return 1;
    }
*/

//    SymEnemerateSymbols(h, 
/*
    while (1) {
        if (!SymGetSymNext(h, &sym)) {
            winerror("SymGetSymNext");
            return 1;
        }
        fp(sym.Name, sym.Address);
    }
*/

/*
//    printf("entering win32 initialize\n");
    ss = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, 0);
    if (!ss) {
        perror("CreateToolhelp32Snapshot");
        return 1;
    }
    me.dwSize = 1024;
    if (!Module32First(ss, &me)) {
        perror("Module32First");
        return 1;
    }
    if (load_arch(fp, &me)) return 1;
    for (;;) {
        me.dwSize = 1024;
        if (!Module32Next(ss, &me)) {
            return 0;
        }
        if (load_arch(fp, &me)) return 1;
    }
*/
    return 0;
}

int reflection_init(regsym_cb fp) {
    int ret;

    ret = init_arch(fp);

    return ret;
}
